--## Locals and tables ##
local ESINT_Total = 0
local ESprf = "default"
local EStP0 = 0
local EStP1 = 0
local EStP2 = 0
local EStP3 = 0
local EStP4 = 0
local InsTar = ""
local sequence = 1
local pWrl = 0
local p0 = 0
local p1 = 0
local p2 = 0
local p3 = 0
local p4 = 0
local Tsp0 = 0
local Tsp1 = 0
local Tsp2 = 0
local Tsp3 = 0
local Tsp4 = 0
local text_Mask = "Interface\\Addons\\ES_Interrupt\\img\\Mask.tga"
local text_Border = "Interface\\Addons\\ES_Interrupt\\img\\Border.tga"
local ES_font = "Interface\\Addons\\ES_Interrupt\\font\\NotoSans-Regular.ttf"
local Cn = ""


if (ESINT_DB == nil) then
	ESINT_DB = {
		[0] = { f = 1 },
		["default"] = {
			lock = 0,
			scale = 1,
			show = 1,
			x = 0,
			y = 0,
			pref = 0,
		},
	}
end


local ESINT_Spec = {--Spec ID's
    [250] = { texture = "Interface\\ICONS\\spell_deathknight_mindfreeze.blp" },
    [251] = { texture = "Interface\\ICONS\\spell_deathknight_mindfreeze.blp" },
    [252] = { texture = "Interface\\ICONS\\spell_deathknight_mindfreeze.blp" },
    [577] = { texture = "Interface\\ICONS\\ability_demonhunter_consumemagic.blp" },
    [581] = { texture = "Interface\\ICONS\\ability_demonhunter_consumemagic.blp" },
    [102] = { texture = "Interface\\ICONS\\ability_vehicle_sonicshockwave.blp" },
    [103] = { texture = "Interface\\ICONS\\INV_Bone_Skull_04.blp" },
    [104] = { texture = "Interface\\ICONS\\INV_Bone_Skull_04.blp" },
    [253] = { texture = "Interface\\ICONS\\inv_ammo_arrow_03.blp" },
    [254] = { texture = "Interface\\ICONS\\inv_ammo_arrow_03.blp" },
    [255] = { texture = "Interface\\ICONS\\ability_hunter_negate.blp" },
    [62] = { texture = "Interface\\ICONS\\spell_frost_iceshock.blp" },
    [63] = { texture = "Interface\\ICONS\\spell_frost_iceshock.blp" },
    [64] = { texture = "Interface\\ICONS\\spell_frost_iceshock.blp" },
    [268] = { texture = "Interface\\ICONS\\ability_monk_spearhand.blp" },
    [269] = { texture = "Interface\\ICONS\\ability_monk_spearhand.blp" },
    [66] = { texture = "Interface\\ICONS\\spell_holy_rebuke.blp" },
    [70] = { texture = "Interface\\ICONS\\spell_holy_rebuke.blp" },
    [258] = { texture = "Interface\\ICONS\\ability_priest_silence.blp" },
    [259] = { texture = "Interface\\ICONS\\ability_kick.blp" },
    [260] = { texture = "Interface\\ICONS\\ability_kick.blp" },
    [261] = { texture = "Interface\\ICONS\\ability_kick.blp" },
    [262] = { texture = "Interface\\ICONS\\Spell_nature_cyclone.blp" },
    [263] = { texture = "Interface\\ICONS\\Spell_nature_cyclone.blp" },
    [264] = { texture = "Interface\\ICONS\\Spell_nature_cyclone.blp" },
    [71] = { texture = "Interface\\ICONS\\inv_gauntlets_04.blp" },
    [72] = { texture = "Interface\\ICONS\\inv_gauntlets_04.blp" },
    [73] = { texture = "Interface\\ICONS\\inv_gauntlets_04.blp" },
	[265] = { texture = "Interface\\ICONS\\spell_shadow_mindrot.blp" },
	-- Demonology is disabled until I can find a better way to check warlocks
	--[266] = { texture = "Interface\\ICONS\\spell_shadow_mindrot.blp" },
	[267] = { texture = "Interface\\ICONS\\spell_shadow_mindrot.blp" },
}


local ESINT_Ability = {
	[47528] = { cd = 15 }, -- Mind Freeze
	[183752] = { cd = 15 }, -- Disrupt
	[78675] = { cd = 60 }, -- Solar Beam
	[106839] = { cd = 15 }, -- Skull Bash
	[147362] = { cd = 24 }, -- Counter Shot
	[187707] = { cd = 15 }, -- Muzzle
	[2139] = { cd = 24 }, -- Counterspell
	[116705] = { cd = 15 }, -- Spear Hand Strike
	[96231] = { cd = 15 }, -- Rebuke
	[15487] = { cd = 45 }, -- Silence
	[1766] = { cd = 15 }, -- Kick
	[57994] = { cd = 12 }, -- Wind Shear
	[6552] = { cd = 15 }, -- Pummel
	[119910] = { cd = 24 },  -- Spell Lock  (With pet)
	[132409] = { cd = 24 }, -- Spell Lock (With Sacrifice)
}


local ES_SL = {
	[0] = {
		sh = 0,
        nr = 0,
    },
	[1] = {
		sh = 0,
        nr = 0,
    },
	[2] = {
		sh = 0,
        nr = 0,
    },
	[3] = {
		sh = 0,
        nr = 0,
    },
	[4] = {
		sh = 0,
        nr = 0,
    },
	[9] = {
		nr = 0,
	},
}


local ES_yC = {
    [1] = -64,
    [2] = -124,
    [3] = -184,
    [4] = -244,
    [5] = -304,
}


local function GetTranslation()
	local lang = GetLocale()
	if (lang == "frFR") then
		return "Commandement démoniaque"
	elseif (lang == "deDE") then
		return "Dämon kommandieren"
	elseif (lang == "itIT") then
		return "Ordine Demoniaco"
	elseif (lang == "koKR") then
		return "악마 조종"
	elseif (lang == "zhCN") then
		return "恶魔掌控"
	elseif (lang == "zhTW") then
		return "惡魔號令"
	elseif (lang == "ruRU") then
		return "Управление демоном"
	elseif (lang == "esES") then
		return "Dominar demonio"
	elseif (lang == "esMX") then
		return "Orden demoníaca"
	elseif (lang == "ptBR") then
		return "Comandar Demônio"
	else -- Default to English
		return "Command Demon"
	end
end


local function PetLocalization()
	local lang = GetLocale()
	if (lang == "frFR") then
		return "Chasseur corrompu"
	elseif (lang == "deDE") then
		return "Teufelsjäger"
	elseif (lang == "itIT") then
		return "Vilsegugio"
	elseif (lang == "koKR") then
		return "지옥사냥개"
	elseif (lang == "zhCN") then
		return "地狱猎犬"
	elseif (lang == "zhTW") then
		return "惡魔獵犬"
	elseif (lang == "ruRU") then
		return "Охотник Скверны"
	elseif (lang == "esES") then
		return "Manáfago"
	elseif (lang == "esMX") then
		return "Manáfago"
	elseif (lang == "ptBR") then
		return "Caçador Vil"
	else -- Default to English
		return "Felhunter"
	end
end


--## Create frames ##
ES_Interrupt = {};
local ESINT_Anchor = CreateFrame("Frame","ES_INT_Anchor", WorldFrame)
local ESINT_Container = CreateFrame("Frame","ES_INT_Container", UIParent, BackdropTemplateMixin and "BackdropTemplate")
local ESINT_AnchorCont = CreateFrame("Frame","ES_INT_Unlock", UIParent, BackdropTemplateMixin and "BackdropTemplate")
local ESINT_PartyListener = CreateFrame("Frame","ES_INT_PartyListener", UIParent)
local ESINT_Loadlistener = CreateFrame("Frame","ES_INT_Loadlistener", UIParent)
local ESINT_Looptimer = CreateFrame("Frame","ES_INT_Looptimer", ESINT_Container)
ES_Interrupt.panel = CreateFrame("Frame", "ES_InterruptPanel", UIParent);
local ESINTtitle = CreateFrame("Frame", "ESINTtitle", ES_InterruptPanel)
local ESINTlockcheck = CreateFrame("CheckButton", "ESINTlockcheck", ES_InterruptPanel, "InterfaceOptionsCheckButtonTemplate")
local ESINTspeccheck = CreateFrame("CheckButton", "ESINTspeccheck", ES_InterruptPanel, "InterfaceOptionsCheckButtonTemplate")
local ESINTshowcheck = CreateFrame("CheckButton", "ESINTshowcheck", ES_InterruptPanel, "InterfaceOptionsCheckButtonTemplate")
local ESINTScaleF = CreateFrame("Slider", "ESINTScaleFrame", ES_InterruptPanel, "OptionsSliderTemplate")
local ESINT_Party0 = CreateFrame("Frame","ES_INT_Party0", ESINT_Container)
local ESINT_Party0cd = CreateFrame("Cooldown","ES_INT_cd0", ESINT_Party0, "CooldownFrameTemplate")
local ESINT_Party0brd = CreateFrame("Frame","ES_INT_brd0", ESINT_Party0)
local ESINT_Party1 = CreateFrame("Frame","ES_INT_Party1", ESINT_Container)
local ESINT_Party1cd = CreateFrame("Cooldown","ES_INT_cd1", ESINT_Party1, "CooldownFrameTemplate")
local ESINT_Party1brd = CreateFrame("Frame","ES_INT_brd1", ESINT_Party1)
local ESINT_Party2 = CreateFrame("Frame","ES_INT_Party2", ESINT_Container)
local ESINT_Party2cd = CreateFrame("Cooldown","ES_INT_cd2", ESINT_Party2, "CooldownFrameTemplate")
local ESINT_Party2brd = CreateFrame("Frame","ES_INT_brd2", ESINT_Party2)
local ESINT_Party3 = CreateFrame("Frame","ES_INT_Party3", ESINT_Container)
local ESINT_Party3cd = CreateFrame("Cooldown","ES_INT_cd3", ESINT_Party3, "CooldownFrameTemplate")
local ESINT_Party3brd = CreateFrame("Frame","ES_INT_brd3", ESINT_Party3)
local ESINT_Party4 = CreateFrame("Frame","ES_INT_Party4", ESINT_Container)
local ESINT_Party4cd = CreateFrame("Cooldown","ES_INT_cd4", ESINT_Party4, "CooldownFrameTemplate")
local ESINT_Party4brd = CreateFrame("Frame","ES_INT_brd4", ESINT_Party4)


--## ESINT_Anchor ##
ESINT_Anchor:SetWidth(8);
ESINT_Anchor:SetHeight(8);
ESINT_Anchor:SetFrameStrata("LOW");
ESINT_Anchor:SetClampedToScreen(true)
ESINT_Anchor.texture = ESINT_Anchor:CreateTexture(nil)
ESINT_Anchor.texture:SetTexture("Interface\\ICONS\\Ability_Malkorok_BlightofYshaarj_Green.blp")
ESINT_Anchor.texture:SetAllPoints(ESINT_Anchor)
ESINT_Anchor:RegisterForDrag("LeftButton")
ESINT_AnchorCont:SetWidth(64)
ESINT_AnchorCont:SetHeight(304)
ESINT_AnchorCont:SetFrameStrata("LOW");
ESINT_AnchorCont:SetClampedToScreen(true)
ESINT_AnchorCont:SetPoint("TOPLEFT", ESINT_Anchor, "BOTTOMRIGHT")
ESINT_AnchorCont:SetBackdrop( { 
  bgFile = "I", 
  edgeFile = "", tile = false, tileSize = 0, edgeSize = 64, 
  insets = { left = 0, right = 0, top = 0, bottom = 0 }
});
ESINT_AnchorCont:SetBackdropColor(0,1,0,0.2);


--## ESINT_Container ##
ESINT_Container:SetWidth(64)
ESINT_Container:SetHeight(304)
ESINT_Container:SetFrameStrata("LOW");
ESINT_Container:SetClampedToScreen(true)
ESINT_Container:SetPoint("TOPLEFT", ESINT_Anchor, "BOTTOMRIGHT")
ESINT_Container:Hide()


--## ESINT_Party0 ##
ESINT_Party0:SetWidth(64)
ESINT_Party0:SetHeight(64)
ESINT_Party0:SetFrameStrata("LOW")
ESINT_Party0.texture = ESINT_Party0:CreateTexture(nil)
ESINT_Party0.texture:SetAllPoints(ESINT_Party0)
ESINT_Party0.texture:SetMask(text_Mask)
ESINT_Party0.font = ESINT_Party0:CreateFontString(nil)
ESINT_Party0.font:SetFont(ES_font, 16, "OUTLINE")
ESINT_Party0.font:SetPoint("LEFT", ESINT_Party0, "RIGHT");
ESINT_Party0.font:SetText("");
ESINT_Party0cd:SetAllPoints(ESINT_Party0)
ESINT_Party0cd:SetSwipeTexture(text_Mask)
ESINT_Party0cd:SetDrawEdge(false)
ESINT_Party0cd:SetBlingTexture(text_Mask)
ESINT_Party0brd:SetAllPoints(ESINT_Party0)
ESINT_Party0brd.texture = ESINT_Party0brd:CreateTexture(nil, "MEDIUM")
ESINT_Party0brd.texture:SetWidth(64)
ESINT_Party0brd.texture:SetHeight(64)
ESINT_Party0brd.texture:SetPoint("CENTER", ESINT_Party0, "CENTER")
ESINT_Party0brd.texture:SetTexture(text_Border)
ESINT_Party0:Hide()


--## ESINT_Party1 ##
ESINT_Party1:SetWidth(64)
ESINT_Party1:SetHeight(64)
ESINT_Party1:SetFrameStrata("LOW")
ESINT_Party1.texture = ESINT_Party1:CreateTexture(nil)
ESINT_Party1.texture:SetAllPoints(ESINT_Party1)
ESINT_Party1.texture:SetMask(text_Mask)
ESINT_Party1.font = ESINT_Party1:CreateFontString(nil)
ESINT_Party1.font:SetFont(ES_font, 16, "OUTLINE")
ESINT_Party1.font:SetPoint("LEFT", ESINT_Party1, "RIGHT");
ESINT_Party1.font:SetText("");
ESINT_Party1cd:SetAllPoints(ESINT_Party1)
ESINT_Party1cd:SetSwipeTexture(text_Mask)
ESINT_Party1cd:SetDrawEdge(false)
ESINT_Party1cd:SetBlingTexture(text_Mask)
ESINT_Party1brd:SetAllPoints(ESINT_Party1)
ESINT_Party1brd.texture = ESINT_Party1brd:CreateTexture(nil, "MEDIUM")
ESINT_Party1brd.texture:SetWidth(64)
ESINT_Party1brd.texture:SetHeight(64)
ESINT_Party1brd.texture:SetPoint("CENTER", ESINT_Party1, "CENTER")
ESINT_Party1brd.texture:SetTexture(text_Border)
ESINT_Party1:Hide()


--## ESINT_Party2 ##
ESINT_Party2:SetWidth(64)
ESINT_Party2:SetHeight(64)
ESINT_Party2:SetFrameStrata("LOW")
ESINT_Party2.texture = ESINT_Party2:CreateTexture(nil)
ESINT_Party2.texture:SetAllPoints(ESINT_Party2)
ESINT_Party2.texture:SetMask(text_Mask)
ESINT_Party2.font = ESINT_Party2:CreateFontString(nil)
ESINT_Party2.font:SetFont(ES_font, 16, "OUTLINE")
ESINT_Party2.font:SetPoint("LEFT", ESINT_Party2, "RIGHT");
ESINT_Party2.font:SetText("");
ESINT_Party2cd:SetAllPoints(ESINT_Party2)
ESINT_Party2cd:SetSwipeTexture(text_Mask)
ESINT_Party2cd:SetDrawEdge(false)
ESINT_Party2cd:SetBlingTexture(text_Mask)
ESINT_Party2brd:SetAllPoints(ESINT_Party2)
ESINT_Party2brd.texture = ESINT_Party2brd:CreateTexture(nil, "MEDIUM")
ESINT_Party2brd.texture:SetWidth(64)
ESINT_Party2brd.texture:SetHeight(64)
ESINT_Party2brd.texture:SetPoint("CENTER", ESINT_Party2, "CENTER")
ESINT_Party2brd.texture:SetTexture(text_Border)
ESINT_Party2:Hide()


--## ESINT_Party3 ##
ESINT_Party3:SetWidth(64)
ESINT_Party3:SetHeight(64)
ESINT_Party3:SetFrameStrata("LOW")
ESINT_Party3.texture = ESINT_Party3:CreateTexture(nil)
ESINT_Party3.texture:SetAllPoints(ESINT_Party3)
ESINT_Party3.texture:SetMask(text_Mask)
ESINT_Party3.font = ESINT_Party3:CreateFontString(nil)
ESINT_Party3.font:SetFont(ES_font, 16, "OUTLINE")
ESINT_Party3.font:SetPoint("LEFT", ESINT_Party3, "RIGHT");
ESINT_Party3.font:SetText("");
ESINT_Party3cd:SetAllPoints(ESINT_Party3)
ESINT_Party3cd:SetSwipeTexture(text_Mask)
ESINT_Party3cd:SetDrawEdge(false)
ESINT_Party3cd:SetBlingTexture(text_Mask)
ESINT_Party3brd:SetAllPoints(ESINT_Party3)
ESINT_Party3brd.texture = ESINT_Party3brd:CreateTexture(nil, "MEDIUM")
ESINT_Party3brd.texture:SetWidth(64)
ESINT_Party3brd.texture:SetHeight(64)
ESINT_Party3brd.texture:SetPoint("CENTER", ESINT_Party3, "CENTER")
ESINT_Party3brd.texture:SetTexture(text_Border)
ESINT_Party3:Hide()


--## ESINT_Party4 ##
ESINT_Party4:SetWidth(64)
ESINT_Party4:SetHeight(64)
ESINT_Party4:SetFrameStrata("LOW")
ESINT_Party4.texture = ESINT_Party4:CreateTexture(nil)
ESINT_Party4.texture:SetAllPoints(ESINT_Party4)
ESINT_Party4.texture:SetMask(text_Mask)
ESINT_Party4.font = ESINT_Party4:CreateFontString(nil)
ESINT_Party4.font:SetFont(ES_font, 16, "OUTLINE")
ESINT_Party4.font:SetPoint("LEFT", ESINT_Party4, "RIGHT");
ESINT_Party4.font:SetText("");
ESINT_Party4cd:SetAllPoints(ESINT_Party4)
ESINT_Party4cd:SetSwipeTexture(text_Mask)
ESINT_Party4cd:SetDrawEdge(false)
ESINT_Party4cd:SetBlingTexture(text_Mask)
ESINT_Party4brd:SetAllPoints(ESINT_Party4)
ESINT_Party4brd.texture = ESINT_Party4brd:CreateTexture(nil, "MEDIUM")
ESINT_Party4brd.texture:SetWidth(64)
ESINT_Party4brd.texture:SetHeight(64)
ESINT_Party4brd.texture:SetPoint("CENTER", ESINT_Party4, "CENTER")
ESINT_Party4brd.texture:SetTexture(text_Border)
ESINT_Party4:Hide()


--## ESINT_Anchor Move ##
ESINT_Anchor:SetScript("OnDragStart", function(self)
	ESINT_Anchor:StartMoving()
end)


ESINT_Anchor:SetScript("OnDragStop", function(self)
	local point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint("TOPLEFT", WorldFrame, "TOPLEFT")
	ESINT_DB[ESprf].x = xOfs
	ESINT_DB[ESprf].y = yOfs
	self:StopMovingOrSizing()
	ESINT_Anchor:ClearAllPoints();
	ESINT_Anchor:SetPoint("TOPLEFT", WorldFrame, "TOPLEFT", ESINT_DB[ESprf].x, ESINT_DB[ESprf].y)
end)

local function ESINT_ToggleLock(arg1)
	if (ESINT_DB[ESprf].lock == 0) and (arg1 ~= "reset") then
		ESINTlockcheck:SetChecked(true)
		ESINT_DB[ESprf].lock = 1
		ESINT_Anchor:Hide()
		ESINT_AnchorCont:Hide()
		ESINT_Container:SetBackdropColor(0,0,0,0);
		ESINT_Anchor:SetMovable(false)
		ESINT_Anchor:EnableMouse(false)
	else
		ESINTlockcheck:SetChecked(false)
		ESINT_DB[ESprf].lock = 0
		ESINT_Anchor:Show()
		ESINT_AnchorCont:Show()
		ESINT_Container:SetBackdropColor(0,1,0,0.2);
		ESINT_Anchor:SetMovable(true)
		ESINT_Anchor:EnableMouse(true)
	end
end

local function ESINT_Reset()
	local sCs = UIParent:GetEffectiveScale()
	local sCw = (GetScreenWidth() * sCs)/2
	local sCh = (GetScreenHeight() * sCs)/2
	ESINT_DB[ESprf].x = sCw
	ESINT_DB[ESprf].y = sCh * (-1)
	ESINT_Anchor:SetPoint("TOPLEFT", WorldFrame, "TOPLEFT", ESINT_DB[ESprf].x, ESINT_DB[ESprf].y)
	ESINT_ToggleLock("reset")
end


local function MergeTable(a, b)
	for k,v in pairs(b) do
		if a[k] == nil or type(a[k]) ~= type(b[k]) then
			a[k] = v
		elseif type(v) == 'table' then
			a[k] = MergeTable(a[k], b[k])
		end
	end
	return a
end


--## Load Addon and saved variables ##
ESINT_Loadlistener:RegisterEvent("PLAYER_ENTERING_WORLD")

local function ESINT_Loadlistener_eventHandler(self, event, ...)
	if (ESINT_DB[0].f == 1) then
		ESINT_DB[0].f = 0
		ESINT_Reset()
	end
	local Pn, Sn = UnitFullName("player")
	Cn = Pn .. "-" .. Sn
	local sCs = UIParent:GetEffectiveScale()
	local sCw = (GetScreenWidth() * sCs)/2
	local sCh = (GetScreenHeight() * sCs)/2
	if not (ESINT_DB[Cn]) then
		ES_TMPdb = {
			[Cn] = {
				lock = 0,
				scale = 1,
				show = 1,
				x = sCw,
				y = sCh * (-1),
				pref = 0
			},
		}
		MergeTable(ESINT_DB, ES_TMPdb)
	end
	if (ESINT_DB[Cn].pref == 1) then
		ESprf = Cn
	end
	
	ESINT_PartyListener:Show()
	ESINTScaleF:SetValue(string.format("%.2f", ESINT_DB[ESprf].scale))
	ESINT_Container:SetScale(ESINT_DB[ESprf].scale)
	ESINT_AnchorCont:SetScale(ESINT_DB[ESprf].scale)
	ESINT_Anchor:SetPoint("TOPLEFT", WorldFrame, "TOPLEFT", ESINT_DB[ESprf].x, ESINT_DB[ESprf].y)
-- Check saved settings for options
	if (ESINT_DB[ESprf].lock == 1) then
		ESINT_Anchor:Hide()
		ESINT_AnchorCont:Hide()
		ESINTlockcheck:SetChecked(true)
		ESINT_Anchor:SetMovable(false)
		ESINT_Anchor:EnableMouse(false)
	else
		ESINT_Anchor:Show()
		ESINT_AnchorCont:Show()
		ESINTlockcheck:SetChecked(false)
		ESINT_Anchor:SetMovable(true)
		ESINT_Anchor:EnableMouse(true)
	end
	if (ESINT_DB[ESprf].show == 1) then
		ESINTshowcheck:SetChecked(true)
	else
		ESINTshowcheck:SetChecked(false)
	end
end

ESINT_Loadlistener:SetScript("OnEvent", ESINT_Loadlistener_eventHandler)


local function ES_Compare(arg1, arg2)
	local cT = GetTime()
	local sT0, dur0 = ESINT_Party0cd:GetCooldownTimes()
	local sT1, dur1 = ESINT_Party1cd:GetCooldownTimes()
	local sT2, dur2 = ESINT_Party2cd:GetCooldownTimes()
	local sT3, dur3 = ESINT_Party3cd:GetCooldownTimes()
	local sT4, dur4 = ESINT_Party4cd:GetCooldownTimes()
	local CD0 = 0
	local CD1 = 0
	local CD2 = 0
	local CD3 = 0
	local CD4 = 0
	local tCD0 = tonumber(string.format("%.1f", (dur0/1000) - (cT - (sT0/1000))))
	local tCD1 = tonumber(string.format("%.1f", (dur1/1000) - (cT - (sT1/1000))))
	local tCD2 = tonumber(string.format("%.1f", (dur2/1000) - (cT - (sT2/1000))))
	local tCD3 = tonumber(string.format("%.1f", (dur3/1000) - (cT - (sT3/1000))))
	local tCD4 = tonumber(string.format("%.1f", (dur4/1000) - (cT - (sT4/1000))))
	if tCD0 > 0 then CD0 = tCD0 end
	if tCD1 > 0 then CD1 = tCD1 end
	if tCD2 > 0 then CD2 = tCD2 end
	if tCD3 > 0 then CD3 = tCD3 end
	if tCD4 > 0 then CD4 = tCD4 end
	if (arg1 == 0) then
		if (arg2 == "P1") then
			if CD0 > CD1 then return true else return false end
		elseif (arg2 == "P2") then
			if CD0 > CD2 then return true else return false end
		elseif (arg2 == "P3") then
			if CD0 > CD3 then return true else return false end
		elseif (arg2 == "P4") then
			if CD0 > CD4 then return true else return false end
		end
	elseif (arg1 == 1) then
		if (arg2 == "P0") then
			if CD1 > CD0 then return true else return false end
		elseif (arg2 == "P2") then
			if CD1 > CD2 then return true else return false end
		elseif (arg2 == "P3") then
			if CD1 > CD3 then return true else return false end
		elseif (arg2 == "P4") then
			if CD1 > CD4 then return true else return false end
		end
	elseif (arg1 == 2) then
		if (arg2 == "P0") then
			if CD2 > CD0 then return true else return false end
		elseif (arg2 == "P1") then
			if CD2 > CD1 then return true else return false end
		elseif (arg2 == "P3") then
			if CD2 > CD3 then return true else return false end
		elseif (arg2 == "P4") then
			if CD2 > CD4 then return true else return false end
		end
	elseif (arg1 == 3) then
		if (arg2 == "P0") then
			if CD3 > CD0 then return true else return false end
		elseif (arg2 == "P1") then
			if CD3 > CD1 then return true else return false end
		elseif (arg2 == "P2") then
			if CD3 > CD2 then return true else return false end
		elseif (arg2 == "P4") then
			if CD3 > CD4 then return true else return false end
		end
	elseif (arg1 == 4) then
		if (arg2 == "P0") then
			if CD4 > CD0 then return true else return false end
		elseif (arg2 == "P1") then
			if CD4 > CD1 then return true else return false end
		elseif (arg2 == "P2") then
			if CD4 > CD2 then return true else return false end
		elseif (arg2 == "P3") then
			if CD4 > CD3 then return true else return false end
		end
	end
end


local function ESINT_ArrClean(arg1, arg2, arg3)
	if (ES_SL[0].nr > arg2) and (ES_SL[0].nr <= arg3) then
		ES_SL[0].nr = ES_SL[0].nr - 1
	end
	if (ES_SL[1].nr > arg2) and (ES_SL[1].nr <= arg3) then
		ES_SL[1].nr = ES_SL[1].nr - 1
	end
	if (ES_SL[2].nr > arg2) and (ES_SL[2].nr <= arg3) then
		ES_SL[2].nr = ES_SL[2].nr - 1
	end
	if (ES_SL[3].nr > arg2) and (ES_SL[3].nr <= arg3) then
		ES_SL[3].nr = ES_SL[3].nr - 1
	end
	if (ES_SL[4].nr > arg2) and (ES_SL[4].nr <= arg3) then
		ES_SL[4].nr = ES_SL[4].nr - 1
	end
		
	if (arg1 == 0) then
		ES_SL[0].nr = arg3
	elseif (arg1 == 1) then
		ES_SL[1].nr = arg3
	elseif (arg1 == 2) then
		ES_SL[2].nr = arg3
	elseif (arg1 == 3) then
		ES_SL[3].nr = arg3
	elseif (arg1 == 4) then
		ES_SL[4].nr = arg3
	end
end


local function ESINT_Arrange(arg1, arg2)
	local tpnr = 0
	
	-- ##
	if (arg1 == "UF") then
		if (arg2 == 0) then
			tpnr = ES_SL[0].nr
			ES_SL[0].nr = 0
		elseif (arg2 == 1) then
			tpnr = ES_SL[1].nr
			ES_SL[1].nr = 0
		elseif (arg2 == 2) then
			tpnr = ES_SL[2].nr
			ES_SL[2].nr = 0
		elseif (arg2 == 3) then
			tpnr = ES_SL[3].nr
			ES_SL[3].nr = 0
		elseif (arg2 == 4) then
			tpnr = ES_SL[4].nr
			ES_SL[4].nr = 0
		end
		
		for i = 1, 5, 1 do
			if (tpnr == 5) then return end
			
			if (tpnr + 1 == ES_SL[0].nr) then
				ES_SL[0].nr = ES_SL[0].nr - 1
			elseif (tpnr + 1 == ES_SL[1].nr) then
				ES_SL[1].nr = ES_SL[1].nr - 1
			elseif (tpnr + 1 == ES_SL[2].nr) then
				ES_SL[2].nr = ES_SL[2].nr - 1
			elseif (tpnr + 1 == ES_SL[3].nr) then
				ES_SL[3].nr = ES_SL[3].nr - 1
			elseif (tpnr + 1 == ES_SL[4].nr) then
				ES_SL[4].nr = ES_SL[4].nr - 1
			end
			tpnr = tpnr + 1
		end
		
		return
	end
	
	-- ##
	if (arg1 ~= "UF") and (arg1 ~= "CD") then
		if (ES_SL[0].sh == 1) and (ES_SL[0].nr == 0) then
			ES_SL[9].nr = ES_SL[9].nr + 1
			ES_SL[0].nr = ES_SL[9].nr
		end
		if (ES_SL[1].sh == 1) and (ES_SL[1].nr == 0) then
			ES_SL[9].nr = ES_SL[9].nr + 1
			ES_SL[1].nr = ES_SL[9].nr
		end
		if (ES_SL[2].sh == 1) and (ES_SL[2].nr == 0) then
			ES_SL[9].nr = ES_SL[9].nr + 1
			ES_SL[2].nr = ES_SL[9].nr
		end
		if (ES_SL[3].sh == 1) and (ES_SL[3].nr == 0) then
			ES_SL[9].nr = ES_SL[9].nr + 1
			ES_SL[3].nr = ES_SL[9].nr
		end
		if (ES_SL[4].sh == 1) and (ES_SL[4].nr == 0) then
			ES_SL[9].nr = ES_SL[9].nr + 1
			ES_SL[4].nr = ES_SL[9].nr
		end
	end

	-- ##
	if (arg1 == "CD") then
		tpnr = ES_SL[arg2].nr
		local min = tpnr + 1
		
		if ES_SL[9].nr > tpnr then
			for i = ES_SL[9].nr, min, -1 do
				if (i == ES_SL[0].nr) then
					if ES_Compare(arg2, "P0") then
						ESINT_ArrClean(arg2, tpnr, i)
						break
					end
				elseif (i == ES_SL[1].nr) then
					if ES_Compare(arg2, "P1") then
						ESINT_ArrClean(arg2, tpnr, i)
						break
					end
				elseif (i == ES_SL[2].nr) then
					if ES_Compare(arg2, "P2") then
						ESINT_ArrClean(arg2, tpnr, i)
						break
					end
				elseif (i == ES_SL[3].nr) then
					if ES_Compare(arg2, "P3") then
						ESINT_ArrClean(arg2, tpnr, i)
						break
					end
				elseif (i == ES_SL[4].nr) then
					if ES_Compare(arg2, "P4") then
						ESINT_ArrClean(arg2, tpnr, i)
						break
					end
				end
			end
		end
	end
	
	if (ES_SL[0].sh == 1) then
		ESINT_Party0:SetPoint("BOTTOMLEFT",ESINT_Anchor,"BOTTOMRIGHT",0,ES_yC[ES_SL[0].nr])
	end
	if (ES_SL[1].sh == 1) then
		ESINT_Party1:SetPoint("BOTTOMLEFT",ESINT_Anchor,"BOTTOMRIGHT",0,ES_yC[ES_SL[1].nr])
	end
	if (ES_SL[2].sh == 1) then
		ESINT_Party2:SetPoint("BOTTOMLEFT",ESINT_Anchor,"BOTTOMRIGHT",0,ES_yC[ES_SL[2].nr])
	end
	if (ES_SL[3].sh == 1) then
		ESINT_Party3:SetPoint("BOTTOMLEFT",ESINT_Anchor,"BOTTOMRIGHT",0,ES_yC[ES_SL[3].nr])
	end
	if (ES_SL[4].sh == 1) then
		ESINT_Party4:SetPoint("BOTTOMLEFT",ESINT_Anchor,"BOTTOMRIGHT",0,ES_yC[ES_SL[4].nr])
	end
end


--## Listen for spellcast ##
ESINT_Container:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")

local function ESINT_Container_eventHandler(self, event, arg1, arg2, arg3)
	cRaid = IsInRaid()
	cGroup = IsInGroup()
	if (cRaid == false) and (cGroup == true) and (ESINT_DB[ESprf].show == 1) then
		if (ESINT_Ability[arg3]) then
			cTime = GetTime()
			cCD = ESINT_Ability[arg3].cd
			trueCD = 0
			if (arg1 == "player") and (ESINT_Ability[arg3]) then
				if (arg3 == 15487) and (Tsp0 == 1) then
					trueCD = cCD - 15
				else
					trueCD = cCD
				end
				ESINT_Party0cd:SetCooldown(cTime, trueCD)
				EStP0 = trueCD
				ESINT_Party0.texture:SetVertexColor(1,0.5,0.5)
				ESINT_Arrange("CD", 0)
			elseif (arg1 == "party1") and (ESINT_Ability[arg3]) then
				if (arg3 == 15487) and (Tsp1 == 1) then
					trueCD = cCD - 15
				else
					trueCD = cCD
				end
				ESINT_Party1cd:SetCooldown(cTime, trueCD)
				EStP1 = trueCD
				ESINT_Party1.texture:SetVertexColor(1,0.5,0.5)
				ESINT_Arrange("CD", 1)
			elseif (arg1 == "party2") and (ESINT_Ability[arg3]) then
				if (arg3 == 15487) and (Tsp2 == 1) then
					trueCD = cCD - 15
				else
					trueCD = cCD
				end
				ESINT_Party2cd:SetCooldown(cTime, trueCD)
				EStP2 = trueCD
				ESINT_Party2.texture:SetVertexColor(1,0.5,0.5)
				ESINT_Arrange("CD", 2)
			elseif (arg1 == "party3") and (ESINT_Ability[arg3]) then
				if (arg3 == 15487) and (Tsp3 == 1) then
					trueCD = cCD - 15
				else
					trueCD = cCD
				end
				ESINT_Party3cd:SetCooldown(cTime, trueCD)
				EStP3 = trueCD
				ESINT_Party3.texture:SetVertexColor(1,0.5,0.5)
				ESINT_Arrange("CD", 3)
			elseif (arg1 == "party4") and (ESINT_Ability[arg3]) then
				if (arg3 == 15487) and (Tsp4 == 1) then
					trueCD = cCD - 15
				else
					trueCD = cCD
				end
				ESINT_Party4cd:SetCooldown(cTime, trueCD)
				EStP4 = trueCD
				ESINT_Party4.texture:SetVertexColor(1,0.5,0.5)
				ESINT_Arrange("CD", 4)
			end
		end
	end
end

ESINT_Container:SetScript("OnEvent", ESINT_Container_eventHandler) 


local function ClassColor(index)
	if (index == 1) then
		return 0.78,0.61,0.43,1
	elseif (index == 2) then
		return 0.96,0.55,0.73,1
	elseif (index == 3) then
		return 0.67,0.83,0.45,1
	elseif (index == 4) then
		return 1.00,0.96,0.41,1
	elseif (index == 5) then
		return 1.00,1.00,1.00,1
	elseif (index == 6) then
		return 0.77,0.12,0.23,1
	elseif (index == 7) then
		return 0.00,0.44,0.87,1
	elseif (index == 8) then
		return 0.41,0.80,0.94,1
	elseif (index == 9) then
		return 0.58,0.51,0.79,1
	elseif (index == 10) then
		return 0.33,0.54,0.52,1
	elseif (index == 11) then
		return 1.00,0.49,0.04,1
	elseif (index == 12) then
		return 0.64,0.19,0.79,1
	end
end


local function ESINT_WlPet(unit)
	local _, _, c = UnitClass(unit)
	local pet = "partypet" .. string.sub(unit, -1)
	
	if (c == 9) and UnitExists(pet) then
		if (UnitCreatureFamily(pet) == PetLocalization()) then
			return true
		else
			return false
		end
	else
		return true
	end
end

local function ESINT_UpdateFrames()
	n0 = UnitName("player")
	_, _, c0 = UnitClass("player")
	n1 = UnitName("party1")
	_, _, c1 = UnitClass("party1")
	n2 = UnitName("party2")
	_, _, c2 = UnitClass("party2")
	n3 = UnitName("party3")
	_, _, c3 = UnitClass("party3")
	n4 = UnitName("party4")
	_, _, c4 = UnitClass("party4")
	
	if (ESINT_Spec[p0]) and (c0 ~= 9) and (ESINT_DB[ESprf].show == 1) then
		ES_SL[0].sh = 1;
		ESINT_Party0:Show()
		ESINT_Party0.texture:SetTexture(ESINT_Spec[p0].texture)
		ESINT_Party0.font:SetText(n0);
		ESINT_Party0.font:SetTextColor(ClassColor(c0))
	elseif (c0 == 9) and (pWrl == 1) and (ESINT_DB[ESprf].show == 1) then
		ES_SL[0].sh = 1;
		ESINT_Party0:Show()
		ESINT_Party0.texture:SetTexture("Interface\\ICONS\\spell_shadow_mindrot.blp")
		ESINT_Party0.font:SetText(n0);
		ESINT_Party0.font:SetTextColor(ClassColor(c0))
	else
		if (ES_SL[0].sh == 1) then
			ES_SL[9].nr = ES_SL[9].nr - 1
			ESINT_Arrange("UF", 0)
		end
		ES_SL[0].sh = 0;
		ESINT_Party0:ClearAllPoints()
		ESINT_Party0:Hide()
		ESINT_Party0.font:SetText("");
	end
	
	if (UnitExists("party1")) and (ESINT_Spec[p1]) and (ESINT_DB[ESprf].show == 1) and ESINT_WlPet("party1") then
		ES_SL[1].sh = 1;
		ESINT_Party1:Show()
		ESINT_Party1.texture:SetTexture(ESINT_Spec[p1].texture)
		ESINT_Party1.font:SetText(n1);
		ESINT_Party1.font:SetTextColor(ClassColor(c1))
	else
		if (ES_SL[1].sh == 1) then
			ES_SL[9].nr = ES_SL[9].nr - 1
			ESINT_Arrange("UF", 1)
		end
		ES_SL[1].sh = 0;
		ESINT_Party1:ClearAllPoints()
		ESINT_Party1:Hide()
		ESINT_Party1.font:SetText("");
	end
	
	if (UnitExists("party2")) and (ESINT_Spec[p2]) and (ESINT_DB[ESprf].show == 1) and ESINT_WlPet("party2") then
		ES_SL[2].sh = 1;
		ESINT_Party2:Show()
		ESINT_Party2.texture:SetTexture(ESINT_Spec[p2].texture)
		ESINT_Party2.font:SetText(n2);
		ESINT_Party2.font:SetTextColor(ClassColor(c2))
	else
		if (ES_SL[2].sh == 1) then
			ES_SL[9].nr = ES_SL[9].nr - 1
			ESINT_Arrange("UF", 2)
		end
		ES_SL[2].sh = 0;
		ESINT_Party2:ClearAllPoints()
		ESINT_Party2:Hide()
		ESINT_Party2.font:SetText("");
	end
	
	if (UnitExists("party3")) and (ESINT_Spec[p3]) and (ESINT_DB[ESprf].show == 1) and ESINT_WlPet("party3") then 
		ES_SL[3].sh = 1;
		ESINT_Party3:Show()
		ESINT_Party3.texture:SetTexture(ESINT_Spec[p3].texture)
		ESINT_Party3.font:SetText(n3);
		ESINT_Party3.font:SetTextColor(ClassColor(c3))
	else
		if (ES_SL[3].sh == 1) then
			ES_SL[9].nr = ES_SL[9].nr - 1
			ESINT_Arrange("UF", 3)
		end
		ES_SL[3].sh = 0;
		ESINT_Party3:ClearAllPoints()
		ESINT_Party3:Hide()
		ESINT_Party3.font:SetText("");
	end
	
	if (UnitExists("party4")) and (ESINT_Spec[p4]) and (ESINT_DB[ESprf].show == 1) and ESINT_WlPet("party4") then 
		ES_SL[4].sh = 1;
		ESINT_Party4:Show()
		ESINT_Party4.texture:SetTexture(ESINT_Spec[p4].texture)
		ESINT_Party4.font:SetText(n4);
		ESINT_Party4.font:SetTextColor(ClassColor(c4))
	else
		if (ES_SL[4].sh == 1) then
			ES_SL[9].nr = ES_SL[9].nr - 1
			ESINT_Arrange("UF", 4)
		end
		ES_SL[4].sh = 0;
		ESINT_Party4:ClearAllPoints()
		ESINT_Party4:Hide()
		ESINT_Party4.font:SetText("");
	end
	
	ESINT_Arrange()
end


local function ESINT_ChkInsWin()
	local checkInsFrame = _G["InspectFrame"]
	
	if (checkInsFrame == nil) then
		return true
	else
		if (checkInsFrame:IsVisible()) then
			return false
		else
			return true
		end
	end
end


local function ESINT_SpcUpd(unit)
	if CanInspect(unit) and (ESINT_ChkInsWin()) then
		InsTar = unit
		NotifyInspect(unit)
		ESINT_PartyListener:RegisterEvent("INSPECT_READY")
	end
end


--## Listen for groupchanges ##
ESINT_PartyListener:RegisterEvent("PLAYER_ENTERING_WORLD")
ESINT_PartyListener:RegisterEvent("GROUP_ROSTER_UPDATE")

local function ESINT_PartyListener_FunctionUpdate(self, event, ...)
	if (event == "PLAYER_ENTERING_WORLD") or (event == "GROUP_ROSTER_UPDATE") then
		cRaid = IsInRaid()
		cGroup = IsInGroup()
		if (cRaid == false) and (cGroup == true) and (ESINT_DB[ESprf].show == 1) then
			ESINT_Container:Show()
		else
			p0 = 0
			p1 = 0
			p2 = 0
			p3 = 0
			p4 = 0
			ESINT_Party0:Hide()
			ESINT_Party1:Hide()
			ESINT_Party2:Hide()
			ESINT_Party3:Hide()
			ESINT_Party4:Hide()
			ESINT_Party0.font:SetText("");
			ESINT_Party1.font:SetText("");
			ESINT_Party2.font:SetText("");
			ESINT_Party3.font:SetText("");
			ESINT_Party4.font:SetText("");
			ES_SL[0].sh = 0
			ES_SL[0].nr = 0
			ES_SL[1].sh = 0
			ES_SL[1].nr = 0
			ES_SL[2].sh = 0
			ES_SL[2].nr = 0
			ES_SL[3].sh = 0
			ES_SL[3].nr = 0
			ES_SL[4].sh = 0
			ES_SL[4].nr = 0
			ES_SL[9].nr = 0
			EStP0 = 0
			EStP1 = 0
			EStP2 = 0
			EStP3 = 0
			EStP4 = 0
			ESINT_Container:Hide()
		end
	end
	if (event == "INSPECT_READY") then
		local specID = GetInspectSpecialization(InsTar)
		local _, _, _, selected = GetTalentInfo(4, 1, 3, true, InsTar)
		ESINT_PartyListener:UnregisterEvent("INSPECT_READY")
		ClearInspectPlayer()
		if (InsTar == "party1") then
			p1 = specID
			if (specID == 258) and (selected == true) then
				Tsp1 = 1
			else
				Tsp1 = 0
			end
		elseif (InsTar == "party2") then
			p2 = specID
			if (specID == 258) and (selected == true) then
				Tsp2 = 1
			else
				Tsp2 = 0
			end
		elseif (InsTar == "party3") then
			p3 = specID
			if (specID == 258) and (selected == true) then
				Tsp3 = 1
			else
				Tsp3 = 0
			end
		elseif (InsTar == "party4") then
			p4 = specID
			if (specID == 258) and (selected == true) then
				Tsp4 = 1
			else
				Tsp4 = 0
			end
		end
		
		ESINT_UpdateFrames()
		
		InsTar = ""
		sequence = sequence + 1
	end
end

ESINT_PartyListener:SetScript("OnEvent", ESINT_PartyListener_FunctionUpdate)


local function ESINT_Cache()
	tp0 = GetSpecializationInfoByID(GetSpecializationInfo(GetSpecialization()))
	local _, _, _, selected = GetTalentInfoByID(23137, (GetActiveSpecGroup()))
	local lname = GetTranslation()
	
	if (tp0 == 258) and (selected) then
		Tsp0 = 1
	else
		Tsp0 = 0
	end
	
	if (GetSpellInfo(lname) == GetSpellInfo(119910)) then
		if (pWrl == 0) then
			pWrl = 1
			ESINT_UpdateFrames()
		end
	else
		if (pWrl == 1) then
			pWrl = 0
			ESINT_UpdateFrames()
		end
	end
	
	if (p0 ~= tp0) then
		p0 = tp0
		ESINT_UpdateFrames()
	end
	
	
	if (sequence == 1) then
		if (UnitExists("party1")) and (UnitIsConnected("party1")) then
			ESINT_SpcUpd("party1")
		else
			ESINT_Party1:Hide()
			ESINT_Party1.font:SetText("");
			p1 = 0
			sequence = sequence + 1
		end
	elseif (sequence == 2) then
		if (UnitExists("party2")) and (UnitIsConnected("party2")) then
			ESINT_SpcUpd("party2")
		else
			ESINT_Party2:Hide()
			ESINT_Party2.font:SetText("");
			p2 = 0
			sequence = sequence + 1
		end
	elseif (sequence == 3) then
		if (UnitExists("party3")) and (UnitIsConnected("party3")) then
			ESINT_SpcUpd("party3")
		else
			ESINT_Party3:Hide()
			ESINT_Party3.font:SetText("");
			p3 = 0
			sequence = sequence + 1
		end
	elseif (sequence == 4) then
		if (UnitExists("party4")) and (UnitIsConnected("party4")) then
			ESINT_SpcUpd("party4")
		else
			ESINT_Party4:Hide()
			ESINT_Party4.font:SetText("");
			p4 = 0
			sequence = 1
		end
	else
		sequence = 1
	end
end


--## ESINT_Looptimer ##
local function ESINT_Looptimer_FunctionUpdate(self,elapsed)
	if EStP0 > 0 then
		EStP0 = EStP0 - elapsed
	elseif EStP0 < 0 then
		EStP0 = 0
		ESINT_Party0.texture:SetVertexColor(1,1,1)
	end
	
	if EStP1 > 0 then
		EStP1 = EStP1 - elapsed
	elseif EStP1 < 0 then
		EStP1 = 0
		ESINT_Party1.texture:SetVertexColor(1,1,1)
	end
	
	if EStP2 > 0 then
		EStP2 = EStP2 - elapsed
	elseif EStP2 < 0 then
		EStP2 = 0
		ESINT_Party2.texture:SetVertexColor(1,1,1)
	end
	
	if EStP3 > 0 then
		EStP3 = EStP3 - elapsed
	elseif EStP3 < 0 then
		EStP3 = 0
		ESINT_Party3.texture:SetVertexColor(1,1,1)
	end
	
	if EStP4 > 0 then
		EStP4 = EStP4 - elapsed
	elseif EStP4 < 0 then
		EStP4 = 0
		ESINT_Party4.texture:SetVertexColor(1,1,1)
	end

	ESINT_Total = ESINT_Total + elapsed
	if ESINT_Total >= 1.0 then
		ESINT_Cache()
		ESINT_Total = 0
	end
end

ESINT_Looptimer:SetScript("OnUpdate", ESINT_Looptimer_FunctionUpdate)




--## Interface Options ##--
---------------------------
ES_Interrupt.panel.name = "ES_Interrupt";
InterfaceOptions_AddCategory(ES_Interrupt.panel);


	ESINTtitle:SetPoint("TOPLEFT", 5, -5)
	ESINTtitle:SetScale(1.5)
	ESINTtitle:SetWidth(150)
	ESINTtitle:SetHeight(50)
	ESINTtitle:Show()

local ESINTtitleFS = ESINTtitle:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	ESINTtitleFS:SetText('|cffFFd200ES_Interrupt|r')
	ESINTtitleFS:SetPoint("TOPLEFT", 5, -5)
	
local ESINTinfoFS1 = ESINTtitle:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	ESINTinfoFS1:SetText("Slash commands:")
	ESINTinfoFS1:SetPoint("TOPLEFT", 5, -150)
	
local ESINTinfoFS2 = ESINTtitle:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	ESINTinfoFS2:SetText('|cFF87CEEB/esi toggle  ' .. '|cFFFFFFFF(enable/disable)')
	ESINTinfoFS2:SetPoint("TOPLEFT", 5, -170)
	
local ESINTinfoFS3 = ESINTtitle:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	ESINTinfoFS3:SetText('|cFF87CEEB/esi lock       ' .. '|cFFFFFFFF(lock/unlock)')
	ESINTinfoFS3:SetPoint("TOPLEFT", 5, -184)
	
local ESINTinfoFS4 = ESINTtitle:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
	ESINTinfoFS4:SetText('|cFF87CEEB/esi reset     ' .. '|cFFFFFFFF(reset position and unlock)')
	ESINTinfoFS4:SetPoint("TOPLEFT", 5, -198)


	
--## Char spesific ##
	ESINTspeccheck:ClearAllPoints()
	ESINTspeccheck:SetPoint("TOPLEFT", 25, -50)
	ESINTspeccheck:SetScale(1.0)
	_G[ESINTspeccheck:GetName() .. "Text"]:SetText('|cffFFFFFFUse character-spesific configuration|r')


ESINTspeccheck:SetScript("OnClick", function(self,button,down) 
	if self:GetChecked(true) then
		ESINT_DB[Cn].pref = 1
		ESprf = Cn
	else
		ESINT_DB[Cn].pref = 0
		ESprf = "default"
	end
	
	ESINTScaleF:SetValue(string.format("%.2f", ESINT_DB[ESprf].scale))
	ESINT_Container:SetScale(ESINT_DB[ESprf].scale)
	ESINT_AnchorCont:SetScale(ESINT_DB[ESprf].scale)
	ESINT_Anchor:SetPoint("TOPLEFT", WorldFrame, "TOPLEFT", ESINT_DB[ESprf].x, ESINT_DB[ESprf].y)
	if (ESINT_DB[ESprf].lock == 1) then
		ESINT_Anchor:Hide()
		ESINT_AnchorCont:Hide()
		ESINTlockcheck:SetChecked(true)
		ESINT_Anchor:SetMovable(false)
		ESINT_Anchor:EnableMouse(false)
	else
		ESINT_Anchor:Show()
		ESINT_AnchorCont:Show()
		ESINTlockcheck:SetChecked(false)
		ESINT_Anchor:SetMovable(true)
		ESINT_Anchor:EnableMouse(true)
	end
	if (ESINT_DB[ESprf].show == 1) then
		ESINTshowcheck:SetChecked(true)
	else
		ESINTshowcheck:SetChecked(false)
	end
end)

	
--## Show/Hide ##
	ESINTshowcheck:ClearAllPoints()
	ESINTshowcheck:SetPoint("TOPLEFT", 25, -75)
	ESINTshowcheck:SetScale(1.0)
	_G[ESINTshowcheck:GetName() .. "Text"]:SetText('|cffFFFFFFEnable|r')


ESINTshowcheck:SetScript("OnClick", function(self,button,down) 
	if self:GetChecked(true) then
		ESINT_DB[ESprf].show = 1
		cRaid = IsInRaid()
		cGroup = IsInGroup()
		if (cRaid == false) and (cGroup == true) then
			ESINT_Container:Show()
		else
			ESINT_Container:Hide()
			p0 = 0
			p1 = 0
			p2 = 0
			p3 = 0
			p4 = 0
			ESINT_Party0:Hide()
			ESINT_Party1:Hide()
			ESINT_Party2:Hide()
			ESINT_Party3:Hide()
			ESINT_Party4:Hide()
			ESINT_Party0.font:SetText("");
			ESINT_Party1.font:SetText("");
			ESINT_Party2.font:SetText("");
			ESINT_Party3.font:SetText("");
			ESINT_Party4.font:SetText("");
		end
	else
		ESINT_DB[ESprf].show = 0
		ESINT_Container:Hide()
		p0 = 0
		p1 = 0
		p2 = 0
		p3 = 0
		p4 = 0
		ESINT_Party0:Hide()
		ESINT_Party1:Hide()
		ESINT_Party2:Hide()
		ESINT_Party3:Hide()
		ESINT_Party4:Hide()
		ESINT_Party0.font:SetText("");
		ESINT_Party1.font:SetText("");
		ESINT_Party2.font:SetText("");
		ESINT_Party3.font:SetText("");
		ESINT_Party4.font:SetText("");
	end
end)
	

--## Lock/Unlock ##
	ESINTlockcheck:ClearAllPoints()
	ESINTlockcheck:SetPoint("TOPLEFT", 25, -100)
	ESINTlockcheck:SetScale(1.0)
	_G[ESINTlockcheck:GetName() .. "Text"]:SetText('|cffFFFFFFLock frame|r')


ESINTlockcheck:SetScript("OnClick", function(self,button,down) 
	ESINT_ToggleLock()
end)


--## Scale (sliding bar) ##
	ESINTScaleF:SetWidth(200)
	ESINTScaleF:SetHeight(20)
	ESINTScaleF:SetPoint("TOPLEFT", 30, -150)
	getglobal(ESINTScaleF:GetName() .. 'Low'):SetText('');
	getglobal(ESINTScaleF:GetName() .. 'High'):SetText('');
	getglobal(ESINTScaleF:GetName() .. 'Text'):SetText('Scale');
	ESINTScaleF:Show()
	ESINTScaleF:SetMinMaxValues(0.5, 2.0)
	ESINTScaleF:SetValueStep(0.01)
	ESINTScaleF:SetValue(string.format("%.2f", ESINT_DB[ESprf].scale))
	
local ESINTScaleText = ESINTScaleF:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	ESINTScaleText:SetFormattedText("%.2f", ESINT_DB[ESprf].scale)
	ESINTScaleText:SetPoint("CENTER", 0, -15)
	ESINTScaleText:SetTextHeight(12)
	ESINTScaleText:SetTextColor(1,1,1,1)
	

ESINTScaleF:SetScript("OnValueChanged", function(self, value)
	Size = self:GetValue()
	ESINT_DB[ESprf].scale = string.format("%.2f", Size)
	ESINTScaleText:SetFormattedText("%.2f", ESINT_DB[ESprf].scale)
	ESINT_Container:SetScale(ESINT_DB[ESprf].scale)
	ESINT_AnchorCont:SetScale(ESINT_DB[ESprf].scale)
end)


--## Slash command ##
function ESINTcommands(msg, editbox)
	if msg == 'toggle' then
		if (ESINT_DB[ESprf].show == 1) then
			ESINT_DB[ESprf].show = 0
			ESINT_Container:Hide()
			p0 = 0
			p1 = 0
			p2 = 0
			p3 = 0
			p4 = 0
			ESINT_Party0:Hide()
			ESINT_Party1:Hide()
			ESINT_Party2:Hide()
			ESINT_Party3:Hide()
			ESINT_Party4:Hide()
			ESINT_Party0.font:SetText("");
			ESINT_Party1.font:SetText("");
			ESINT_Party2.font:SetText("");
			ESINT_Party3.font:SetText("");
			ESINT_Party4.font:SetText("");
			ESINTshowcheck:SetChecked(false)
			print('|cFF87CEEB ES_Interrupt:|r' .. '|cffFFd200 Disabled|r')
		else
			ESINT_DB[ESprf].show = 1
			cRaid = IsInRaid()
			cGroup = IsInGroup()
			if (cRaid == false) and (cGroup == true) then
				ESINT_Container:Show()
			else
				ESINT_Container:Hide()
				p0 = 0
				p1 = 0
				p2 = 0
				p3 = 0
				p4 = 0
				ESINT_Party0:Hide()
				ESINT_Party1:Hide()
				ESINT_Party2:Hide()
				ESINT_Party3:Hide()
				ESINT_Party4:Hide()
				ESINT_Party0.font:SetText("");
				ESINT_Party1.font:SetText("");
				ESINT_Party2.font:SetText("");
				ESINT_Party3.font:SetText("");
				ESINT_Party4.font:SetText("");
			end
			ESINTshowcheck:SetChecked(true)
			print('|cFF87CEEB ES_Interrupt:|r' .. '|cffFFd200 Enabled|r')
		end
	elseif msg == 'lock' then
		if (ESINT_DB[ESprf].lock == 0) then
			print('|cFF87CEEB ES_Interrupt:|r' .. '|cffFFd200 Locked|r')
		else
			print('|cFF87CEEB ES_Interrupt:|r' .. '|cffFFd200 Unlocked|r')
		end
		ESINT_ToggleLock()
	elseif msg == 'reset' then
		ESINT_Reset()
		print('|cFF87CEEB ES_Interrupt:|r' .. '|cffFFd200 Reset|r')
	else
		print('\n|cffFFd200Slash commands - |r' .. '|cFF87CEEB ES_Interrupt:|r' .. '\n|cFF87CEEB   /esi toggle |r' .. "(enable/disable)" .. '\n|cFF87CEEB   /esi lock   |r' .. "(lock/unlock)" .. '\n|cFF87CEEB   /esi reset  |r' .. "(reset position and unlock)\n")
	end
end
SLASH_ESINTTOGGLE1 = '/esi';
SlashCmdList["ESINTTOGGLE"] = ESINTcommands